var discussion = discussion || {};

discussion.commentCounts = (function($) {
  var commentLinks;

  function go() {
    if (!discussionApiUrl) {
      return;
    }

    var shortUrls = [];
    commentLinks = jQ('.trail-comment-count, .content-comment-count');
    commentLinks.each(function() {
      $this = $(this);
      $this.hide();
      shortUrls.push($this.attr('short-url').replace(/-/g, '/'));
    });

    var apiRoot = discussionApiUrl;
                               
    $.ajax({
      dataType: 'jsonp',
      jsonpCallback: 'commentCountCallback',
      url: apiRoot + '/discussion-api/getCommentCounts',
      data: { 'short-urls': shortUrls.join(',') },
      cache: true,
      timeout: 10000,
      success: function(data) {
        embedCss();
        populateCounts(data);
      }
    });
  }

  function embedCss() {
    var href = 'http://resource.guim.co.uk/global/static/file/discussion/comment-counts-swimlaned.css';
    $('head').append('<link rel="stylesheet" href="' + href + '">');
  }

  function populateCounts(records) {
    commentLinks.each(function() {
      var $this = $(this);
      var comments = getCommentCount($this);

      if ('undefined' === typeof comments) {
        return;
      }

      if ($this.hasClass('content-comment-count')) {
        $this.show();
        $this.find('.comment-count-val').html(comments);
      }
      else {
        if ($this.hasClass('comments-open')) {
          $this.find('.comment-count-val').html(formatCommentCount(comments));
          $this.show();
        }
        else {
          if (0 < comments) {
            $this.find('.comment-count-val').html(formatCommentCount(comments));
            $this.show();
          }
          else {
            $this.remove();
          }
        }
      }
    });

    function getCommentCount(link) {
      var shortUrl = link.attr('short-url').replace(/-/g, '/');
      var comments = records[shortUrl];
      return comments;
    }

    function formatCommentCount(comments) {
      if (0 === comments) {
        return 'Post your comment';
      }
      else if (1 === comments) {
        return comments + ' comment';
      }
      else {
        return comments + ' comments';
      }
    }
  }

  return {
    'go': go
  };
})(jQ);

jQ(document).ready(function() {
  discussion.commentCounts.go();
});
